import { world, ScoreboardObjective, ItemStack, ItemComponentTypes } from "@minecraft/server";

world.afterEvents.playerBreakBlock.subscribe((event) => {
    const source = event.player;
    const itemStack = event.itemStackAfterBreak;

    if (itemStack && itemStack.typeId === "bey:amethyst_pickaxe") {
        const durability = itemStack.getComponent(ItemComponentTypes.Durability);

        if (durability.damage === durability.maxDurability) {
            source.playSound('random.break');
            source.getComponent('equippable').setEquipment('Mainhand', undefined);
        } else {
            durability.damage++;
            source.getComponent('equippable').setEquipment('Mainhand', itemStack);
        }
    }
});


world.afterEvents.playerBreakBlock.subscribe((event) => {
    const source = event.player;
    const itemStack = event.itemStackAfterBreak;

    if (itemStack && itemStack.typeId == "bey:amethyst_axe") {
        const durability = itemStack.getComponent(ItemComponentTypes.Durability);
        if (durability.damage === durability.maxDurability) {
            source.playSound('random.break');
            source.getComponent('equippable').setEquipment('Mainhand', undefined);
        }
        else {
            durability.damage++;
            source.getComponent('equippable').setEquipment('Mainhand', itemStack);
        }
    }
});


world.afterEvents.playerBreakBlock.subscribe((event => {
    const hasteObj = world.scoreboard.getObjective("hasteCooldown");
    if (hasteObj && event.player) {
        if (event.player.typeId == "minecraft:player") {
            const Hastecore = hasteObj.getScore(event.player);
            if (Hastecore === 0) {
                if (event.itemStackAfterBreak.typeId == "bey:amethyst_pickaxe") {
                    event.player.runCommand("/effect @s haste 2 1")
                    event.player.runCommand("/scoreboard players add @s hasteCooldown 1")
                }
                if (event.itemStackAfterBreak.typeId == "bey:amethyst_axe") {
                    event.player.runCommand("/effect @s haste 2 1")
                    event.player.runCommand("/scoreboard players add @s hasteCooldown 1")
                }
            }
        }
    }
}))

world.afterEvents.entityDie.subscribe((event => {
    let player = event.damageSource?.damagingEntity;
    let killed = event.deadEntity;
    if (player && killed.typeId !== "bey:amthyst_orb") {
        function getMainHand(player) {
            const equippable = player.getComponent('equippable');
            return equippable?.getEquipment('Mainhand');
        }
        if (getMainHand(player)?.typeId === 'bey:amethyst_blade') {
            killed.runCommand("/summon bey:amthyst_orb ~ ~1 ~");
        }
    }
}));

world.afterEvents.entityHitEntity.subscribe((event => {
    if (event.damagingEntity?.typeId == "minecraft:player") {
        if (event.hitEntity.typeId == "bey:amthyst_orb") {
            event.damagingEntity.runCommand("/effect @s regeneration 1 6 true")
            event.damagingEntity.runCommand("/effect @s health_boost 4 2 false")
            event.hitEntity.runCommand("/scoreboard players set @s crystalOrb 80")
        }
    }
}))

world.afterEvents.entityHurt.subscribe((event) => {
    const amethystObj = world.scoreboard.getObjective("overallAmeArmor");
    if (amethystObj && event.hurtEntity) {
        if (event.hurtEntity.typeId == "minecraft:player") {
            const Amescore = amethystObj.getScore(event.hurtEntity);
            if (Amescore === 1) {
                {
                    event.hurtEntity.runCommand("/effect @s regeneration 2 2 true");
                    event.hurtEntity.runCommand("/playsound break.amethyst_cluster @s ~~~");
                }
            }
            if (Amescore === 2) {
                {
                    event.hurtEntity.runCommand("/effect @s regeneration 3 2 true");
                    event.hurtEntity.runCommand("/playsound break.amethyst_cluster @s ~~~");
                }
            }
            if (Amescore === 3) {
                {
                    event.hurtEntity.runCommand("/effect @s regeneration 4 2 true");
                    event.hurtEntity.runCommand("/playsound break.amethyst_cluster @s ~~~");
                }
            }
            if (Amescore === 4) {
                {
                    event.hurtEntity.runCommand("/effect @s regeneration 5 2 true");
                    event.hurtEntity.runCommand("/playsound break.amethyst_cluster @s ~~~");
                }
            }

        }
    }
});